Update for release
[grml-debootstrap.git] / grml-debootstrap
index b97e298..c8075d8 100755 (executable)
@@ -11,7 +11,7 @@ set -e # exit on any error
 
 # variables {{{
 PN="$(basename $0)"
-VERSION='0.19'
+VERSION='0.32'
 MNTPOINT="/mnt/debootstrap.$$"
 
 # inside the chroot system locales might not be available, so use minimum:
@@ -34,28 +34,45 @@ usage() {
 
 Usage: $PN [options]
 
-  -h|--help                   Print this usage information and exit.
-  -v|--version                Show summary of options and exit.
-
-  -c|--config <configfile>    Use specified configuration file,
-                              defaults to /etc/debootstrap/config
-  --hostname <hostname>       Hostname of Debian system
-  -i|--iso <mnt>              Mountpoint where a Debian ISO is mounted to,
-                              for use instead of fetching packages from a mirror
-  -m|--mirror <URL>           Mirror which should be used for apt-get/aptitude.
-  -p|--mntpoint <mnt>         Mountpoint used for mounting the target system.
-  -r|--release <release>      Release of new Debian system (default: stable)
-  -t|--target <target>        Target partition (/dev/...) or directory.
-
-  --boot_append <appendline>  Add specified appendline to kernel whilst booting
-  --groot <device>            Root device for usage in grub, corresponds with
-                              \$TARGET in grub syntax, like hd0,0 for /dev/sda1
-  --grub <device>             Target for grub installation. Use grub syntax
-                              for specifying, like hd0 for /dev/sda
-  --interactive               Use interactive mode (frontend)
-  --password <pwd>            Use specified password as password for user root.
-
-Send bugreports to the grml-team: bugs@grml.org || http://grml.org/bugs/
+Bootstrap options:
+
+  -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
+  -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
+                           instead of fetching packages from a mirror.
+  -r, --release <name>   Release of new Debian system (default: lenny).
+  -t, --target <target>  Target partition (/dev/...) or directory where the
+                         system should be installed to.
+  -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
+                         has no effect if -t is given and represents a directory.
+      --debopt <params>  Extra parameters passed to the debootstrap command.
+      --interactive      Use interactive mode (frontend).
+      --nodebootstrap    Skip debootstrap, only do configuration to the target.
+      --grub <device>    Target for grub installation. Usage example: /dev/sda
+      --arch <arch>      Architecture to use. Currently only i386 is supported.
+
+Configuration options:
+
+  -c, --config <file>      Use specified configuration file, defaults to
+                             /etc/debootstrap/config
+  -d, --confdir <path>     Place of config files for debootstrap, defaults
+                             to /etc/debootstrap
+      --packages <file>    Install packages defined in specified list file.
+      --debconf <file>     Pre-seed packages using specified pre-seed db file.
+      --keep_src_list      Do not overwrite user provided apt sources.list.
+      --hostname <name>    Hostname of Debian system.
+      --password <pwd>     Use specified password as password for user root.
+      --bootappend <line>  Add specified appendline to kernel whilst booting.
+      --chroot-scripts <d> Execute chroot scripts from specified directory.
+      --scripts <dir>      Execute scripts from specified directory.
+
+Other options:
+
+  -v, --verbose            Increase verbosity.
+  -h, --help               Print this usage information and exit.
+  -V, --version            Show summary of options and exit.
+
+Usage examples can be found in the grml-debootstrap manpage.
+Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
 "
 }
 
@@ -74,6 +91,7 @@ check4root || exit 1
 # source configuration file {{{
 if [ -r /etc/debootstrap/config ] ; then
    if [ -n "$CONFIGFILE" ] ; then
+      einfo "Using config file $CONFIGFILE."
       if ! . "$CONFIGFILE" ; then
          eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
       fi
@@ -84,73 +102,65 @@ fi
 # }}}
 
 # cmdline handling {{{
+# source external command line parameter-processing script
+if [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
+   . /usr/share/grml-debootstrap/functions/cmdlineopts.clp
+elif [ -r ./cmdlineopts.clp ] ; then
+   . ./cmdlineopts.clp
+else
+   echo "Error: cmdline function file not found, exiting.">&2
+   exit 1
+fi
 
-while [ "$#" -gt "0" ] ; do
-    case $1 in
-        -c|--config)
-            shift
-            CONFIGFILE=$1
-            ;;
-        --grub)
-            shift
-            GRUB=$1
-            ;;
-        --groot)
-            shift
-            GROOT=$1
-            ;;
-        -h|--help)
-            usage ; eend 0
-            eend 0
-            exit 0
-            ;;
-        --hostname)
-            shift
-            HOSTNAME=$1
-            ;;
-        --interactive)
-            INTERACTIVE=1
-            ;;
-        -i|--iso)
-            shift
-            [ -n "$MIRROR" ] && unset MIRROR
-            ISO=$1
-            ;;
-        -m|--mirror)
-            shift
-            MIRROR=$1
-            CHROOTMIRROR=$1
-            ;;
-        -p|--mntpoint)
-            shift
-            MNTPOINT=$1
-            ;;
-        --password)
-            shift
-            ROOTPASSWORD=$1
-            ;;
-        -r|--release)
-            shift
-            RELEASE=$1
-            ;;
-        -t|--target)
-            shift
-            TARGET=$1
-            ;;
-        -v|--version)
-            einfo "$PN - version $VERSION"
-            einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
-            eend 0
-            exit 0
-            ;;
-        *)
-            eerror "Syntax error."
-            usage ; eend 1
-            exit 1
-            ;;
-    esac
-    shift
-done
+# == business-logic of command line parameter-processing
+
+# source configuration file in <confdir> if supplied. {{{
+[ "$_opt_confdir" ] && {
+  CONFFILES=$_opt_confdir
+  einfo "Using config files under $CONFFILES/."
+  if ! [ -r "$CONFFILES/config" ] ; then
+    eerror "Error: config file $CONFFILES/config not found."; eend 1; exit 1
+  fi
+  if ! . "$CONFFILES/config" ; then
+    eerror "Error reading config file $CONFFILES/config" ; eend 1 ; exit 1
+  fi
+  # restore the command line parameter value
+  CONFFILES=$_opt_confdir
+}
+# }}}
+
+[ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
+[ "$_opt_iso" ]                 && ISO=$_opt_iso
+[ "$_opt_release" ]             && RELEASE=$_opt_release
+[ "$_opt_target" ]              && TARGET=$_opt_target
+[ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
+[ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
+[ "$_opt_interactive" ]         && INTERACTIVE=1
+[ "$_opt_config" ]              && CONFIGFILE=$_opt_config
+[ "$_opt_packages_set" ]        && PACKAGES='yes'
+[ "$_opt_debconf_set" ]         && DEBCONF='yes'
+[ "$_opt_scripts_set" ]         && SCRIPTS='yes'
+[ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
+[ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
+[ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
+[ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
+[ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
+[ "$_opt_grub" ]                && GRUB=$_opt_grub
+[ "$_opt_arch" ]                && ARCH=$_opt_arch
+[ "$_opt_verbose" ]             && VERBOSE="-v"
+
+[ "$_opt_help" ] && {
+  usage ; eend 0
+  eend 0
+  exit 0
+}
+
+[ "$_opt_version" ] && {
+  einfo "$PN - version $VERSION"
+  einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
+  eend 0
+  exit 0
+}
 # }}}
 
 # welcome screen {{{
@@ -167,9 +177,16 @@ prompt_for_target()
   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
                sed 's/*//' | \
                grep -v 'Extended$' | \
-               gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
+               gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md* 2>/dev/null || true);
+
+  if [ -z "$AVAILABLE_PARTITIONS" ] ; then
+     dialog --title "$PN" --trim \
+     --msgbox "Sorry, no partitions found. Please configure your
+     harddisks (see /proc/partitions) using a tool like fdisk,
+     cfdisk, gpart, gparted,..." 0 0
+     exit 0
+  fi
 
-  [ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
   PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
                        echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet])"
                    done)
@@ -184,22 +201,39 @@ prompt_for_target()
 prompt_for_bootmanager()
 {
   ADDITIONAL_PARAMS=""
-  for device in sda hda; do
-    if [ /dev/$device != ${TARGET%[0-9]} ]; then
+
+  if echo "$TARGET" | grep -q "/dev/md" ; then
+     MBRPART="all disks of Software RAID $TARGET"
+  else
+     # figure out whole disk device
+     found=
+     for device in /dev/disk/by-id/*
+     do
+        [ $(readlink -f $device) = ${TARGET} ] || continue
+        found=1
+        break
+     done
+     [ -n "$found" ] && MBRDISK=$(echo ${device}|sed -e 's/-part[0-9][0-9]*$//')
+     if [ -e "$MBRDISK" ]; then
+        MBRDISK=$(readlink -f $MBRDISK)
+     else
+        # fall back to old behaviour
+        MBRDISK=$(echo ${TARGET} | sed -e 's/[0-9][0-9]*$/')
+     fi
+
+     MBRPART="MBR of $MBRDISK"
+  fi
+
+  for device in cciss/c0d0 sda hda; do
+    if [ /dev/$device != ${MBRDISK} ]; then
       grep -q $device /proc/partitions && \
-      ADDITIONAL_PARAMS=:$device:"install bootmanager grub into MBR of /dev/${device}"
+      ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
     fi
   done
   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
 
   OIFS="$IFS"; IFS=:
 
-  if echo $TARGET | grep -q "/dev/md" ; then
-     MBRPART="all disks of Software RAID $TARGET"
-  else
-     MBRPART="MBR of ${TARGET%[0-9]}"
-  fi
-
   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
             mbr       "install bootmanager into $MBRPART" \
@@ -212,23 +246,28 @@ prompt_for_bootmanager()
   case "$GETMBR" in
     mbr)
       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
-      if echo $TARGET | grep -q "*md*" ; then
-         BOOT_PARTITION="${TARGET}"
+      if echo "$TARGET" | grep -q "/dev/md" ; then
+         # using sw-raid:
+         if [ -n "$SELECTED_PARTITIONS" ] ; then
+            GRUB=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
+         else
+            GRUB="$TARGET"
+         fi
       else
-         BOOT_PARTITION="${TARGET%[0-9]}"
+        GRUB="$MBRDISK"
       fi
       ;;
     partition)
-      BOOT_PARTITION="$TARGET"
+      GRUB="$TARGET"
       ;;
     hda)
-      BOOT_PARTITION="/dev/hda"
+      GRUB="/dev/hda"
       ;;
     sda)
-      BOOT_PARTITION="/dev/sda"
+      GRUB="/dev/sda"
       ;;
     nowhere)
-      BOOT_PARTITION=''
+      GRUB=''
       ;;
   esac
 }
@@ -237,12 +276,13 @@ prompt_for_bootmanager()
 # ask for Debian release {{{
 prompt_for_release()
 {
-  RELEASE="$(dialog --stdout --title "${PN}" --default-item etch --menu \
+  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='lenny'
+  RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
             "Please enter the Debian release you would like to use for installation:" \
             0 50 3 \
-            etch   Debian/stable \
-            lenny  Debian/testing \
-            sid    Debian/unstable)"
+            lenny    Debian/stable \
+            squeeze  Debian/testing \
+            sid      Debian/unstable)"
 }
 # }}}
 
@@ -251,55 +291,53 @@ prompt_for_hostname()
 {
   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
             "Please enter the hostname you would like to use for installation:" \
-            0 0 grml)"
+            0 0 $HOSTNAME)"
 }
 # }}}
 
-# ask for Debian mirror {{{
-prompt_for_mirror()
+# ask for password {{{
+prompt_for_password()
 {
-  MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
-            "Please enter Debian mirror you would like to use for installing packages." \
-            0 0 http://ftp.de.debian.org/debian)"
+     ROOTPW1='PW1'
+     ROOTPW2='PW2'
+     while [ "$ROOTPW1" != "$ROOTPW2" ]; do
+       ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
+       "Please enter the password for the root account:" 10 60)
+       ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
+       "Please enter the password for the root account again for \
+       confirmation:" 10 60)
+
+       if [ "$ROOTPW1" != "$ROOTPW2" ]; then
+         $(dialog --stdout --title "${PN}" --ok-label \
+         "Retry" --msgbox "Passwords do not match!" 10 60)
+       fi
+     done
+     ROOTPASSWORD="$ROOTPW1"
 }
 # }}}
 
-# get grub's syntax for /dev/ice {{{
-# usage example: 'grubdevice /dev/sda2' returns 'hd0,1'
-grubdevice() {
-  if [ -z "$1" ] ; then
-     echo "Usage: grubdevice <device>">&2
-     return 1
-  fi
-
-  device="$1"
-  device_map=/boot/grub/device.map
-
-  # create device.map
-  if ! [ -f "$device_map" ] ; then
-     echo 'quit' | grub --device-map="$device_map" 1>/dev/null 2>&1
+# ask for Debian mirror {{{
+prompt_for_mirror()
+{
+  [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
+
+  CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
+          --menu "Where do you want to install from?" 0 0 0 \
+            net   "install via network (downloading from mirror)" \
+            local "install from local directory/mirror"
+          )
+
+  if [ "$CHOOSE_MIRROR" = 'net' ] ; then
+     [ -n "$MIRROR" ] || MIRROR='http://cdn.debian.net/debian'
+     MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
+               "Please enter Debian mirror you would like to use for installing packages." \
+               0 0 $MIRROR)"
+  else # CHROOT_VARIABLES == local
+     [ -n "$ISO" ] || ISO='/mnt/mirror'
+     ISO="$(dialog --stdout --title "${PN}" --inputbox \
+               "Please enter directory name you would like to use for installing packages." \
+               0 0 $ISO)"
   fi
-
-  # based on code from d-i's trunk/packages/arch/i386/grub-installer/grub-installer:
-  tmp_disk=`echo "$device" | sed -e 's%\([sh]d[a-z]\)[0-9]*$%\1%' \
-                    -e 's%\(fd[0-9]*\)$%\1%' \
-                    -e 's%/part[0-9]*$%/disc%' \
-                    -e 's%\(c[0-7]d[0-9]*\).*$%\1%'`
-  tmp_part=`echo "$device" | sed -e 's%.*/[sh]d[a-z]\([0-9]*\)$%\1%' \
-                    -e 's%.*/fd[0-9]*$%%' \
-                    -e 's%.*/floppy/[0-9]*$%%' \
-                    -e 's%.*/\(disc\|part\([0-9]*\)\)$%\2%' \
-                    -e 's%.*c[0-7]d[0-9]*p*%%'`
-  tmp_drive=$(grep -v '^#' $device_map | grep "$tmp_disk *$" | sed 's%.*\([hf]d[0-9][a-g0-9,]*\).*%\1%')
-
-  case $1 in
-     /dev/[sh]d[a-z]) # we expect something like 'hd0'
-        echo "$tmp_drive"
-        ;;
-      *) # we expect something like 'hd0,0'
-        echo "$tmp_drive" | sed "s%$%,`expr $tmp_part - 1`%" # FIXME => md0
-        ;;
-  esac
 }
 # }}}
 
@@ -385,6 +423,19 @@ fi
 }
 # }}}
 
+# user should recheck his configuration {{{
+# support full automatic installation:
+checkforrun() {
+   dialog --timeout 10 --title "$PN" \
+          --yesno "Do you want to stop at this stage?
+
+Notice: you are running ${PN} in non-interactive mode.
+${PN} will install Debian ${RELEASE} on ${TARGET}.
+Last chance to quit. Timeout of 10 seconds running....
+
+Do you want to stop now?" 0 0 2>/dev/null
+}
+
 # make sure the user is aware of the used configuration {{{
 checkconfiguration()
 {
@@ -407,6 +458,8 @@ elif [ -n "$INTERACTIVE" ] ; then
    Using hostname   $HOSTNAME"
    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
    Using mirror:    $MIRROR"
+   [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
+   Using ISO:       $ISO"
 
    INFOTEXT="$INFOTEXT
 
@@ -419,13 +472,19 @@ else # if not running automatic installation display configuration and prompt fo
    einfo "$PN - Please recheck configuration before execution:"
    echo
    echo "   Target:          $TARGET"
-      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
-      [ -n "$GRUB" ]    && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
-      [ -n "$RELEASE" ] && echo "   Using release:   $RELEASE"
-      [ -n "$MIRROR" ]  && echo "   Using mirror:    $MIRROR"
-      [ -n "$ISO" ]     && echo "   Using iso:       $ISO"
-      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
-      echo
+
+   # do not display if MNTPOINT is the default one
+   case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
+
+   [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
+   [ -n "$RELEASE" ]  && echo "   Using release:   $RELEASE"
+   [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
+   [ -n "$HOSTNAME" ] && echo "   Using hostname:  $HOSTNAME"
+   [ -n "$ISO" ]      && echo "   Using ISO:       $ISO"
+
+   echo "   Important! Continuing will delete all data from ${TARGET}!"
+
+   echo
    einfon "Is this ok for you? [y/N] "
    read a
    if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
@@ -443,8 +502,7 @@ interactive_mode()
 
   prompt_for_swraid
 
-  # do not prompt for partition dialog if swraid has been configured already
-  [ -n "$TARGET" ] || prompt_for_target
+  prompt_for_target
 
   prompt_for_bootmanager
 
@@ -452,24 +510,9 @@ interactive_mode()
 
   prompt_for_hostname
 
-  # use first disk of sw-raid for grub by default, install grub on
-  # all involved disks later on
-  if echo "$TARGET" | grep -q '/dev/md' ; then
-     if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
-        # use hdX and not hdX,Y for $GRUB
-        TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
-        GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})" # like: hd0
-        GROOT="$(grubdevice ${TMPDEVICE})"       # like: hd0,0
-        echo "debug: GRUB = $GRUB - GROOT = $GROOT" >/tmp/debug # FIXME
-     fi
-  else
-     [ -n "$BOOT_PARTITION" ] && GRUB="$(grubdevice $BOOT_PARTITION)"
-     [ -n "$TARGET" ]         && GROOT="$(grubdevice $TARGET)"
-  fi
+  prompt_for_password
 
   prompt_for_mirror
-
-  checkconfiguration
 }
 
 # run interactive mode if we didn't get the according configuration yet
@@ -480,11 +523,13 @@ if [ -z "$TARGET" -o -n "$INTERACTIVE" ] ; then
 fi
 # }}}
 
+checkconfiguration
+
 # finally make sure at least $TARGET is set [the partition for the new system] {{{
 if [ -n "$TARGET" ] ; then
    SHORT_TARGET="${TARGET##*/}"
 else
-   eerror "Please adjust /etc/debootstrap/config or..."
+   eerror "Please adjust $CONFFILES/config or..."
    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
    exit 1
 fi
@@ -520,7 +565,6 @@ case $TARGET in
     TUNE2FS=''
     FSCK=''
     GRUB=''
-    GROOT=''
     ;;
 esac
 # }}}
@@ -550,21 +594,6 @@ ISODIR=${ISO##file:}
 ISODIR=${ISODIR%%/}
 # }}}
 
-# provide variables to chroot system {{{
-CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
-touch $CHROOT_VARIABLES
-chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
-[ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  $CHROOT_VARIABLES
-[ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> $CHROOT_VARIABLES
-[ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> $CHROOT_VARIABLES
-[ -n "$TARGET" ] && echo "TARGET=$TARGET" >> $CHROOT_VARIABLES
-[ -n "$ISO" ]    && echo "ISO=$ISO"       >> $CHROOT_VARIABLES
-[ -n "$ISODIR" ] && echo "ISODIR=$ISO"    >> $CHROOT_VARIABLES
-[ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> $CHROOT_VARIABLES
-[ -n "$MIRROR" ] && echo "CHROOTMIRROR=$MIRROR" >> $CHROOT_VARIABLES
-[ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
-# }}}
-
 # helper functions {{{
 # we want to exit smoothly and clean:
 bailout(){
@@ -580,7 +609,12 @@ bailout(){
         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
         [ -d "$MNTPOINT/$ISODIR" ]    && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
-        einfo "Unmounting $MNTPOINT"   ; umount "$MNTPOINT" ; eend $?
+
+        if [ -n "$DIRECTORY" ] ; then
+          einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
+        else
+          einfo "Unmounting $MNTPOINT"   ; umount "$MNTPOINT" ; eend $?
+        fi
 
         if [ -n "$STAGES" ] ; then
            echo -n "Removing stages directory ${STAGES}: "
@@ -616,25 +650,33 @@ stage() {
 }
 # }}}
 
-# user should recheck his configuration {{{
-# support full automatic installation:
-checkforrun() {
-   dialog --timeout 10 --title "$PN" \
-          --yesno "Do you want to stop at this stage?
+# create filesystem {{{
+mkfs() {
+  if [ -n "$DIRECTORY" ] ; then
+     einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
+  else
+    if grep -q "$TARGET" /proc/mounts ; then
+      eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
+      exit 1
+    fi
 
-Notice: you are running ${PN} in non-interactive mode.
-${PN} will install Debian ${RELEASE} on ${TARGET}.
-Last chance to quit. Timeout of 10 seconds running....
+    if [ -n "$MKFS" ] ; then
+       einfo "Running $MKFS on $TARGET"
+       $MKFS $TARGET ; RC=$?
 
-Do you want to stop now?" 0 0 2>/dev/null
-}
+       # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
+       # will fail to detect the uuid in the chroot
+       blockdev --rereadpt "${TARGET%%[0-9]*}"
+       # give the system 2 seconds, otherwise we might run into
+       # race conditions :-/
+       sleep 2
+
+       eval $(blkid -o udev $TARGET 2>/dev/null)
+       [ -n "$ID_FS_UUID" ] && TARGET_UUID="$ID_FS_UUID" || TARGET_UUID=""
+
+       eend $RC
+    fi
 
-# create filesystem {{{
-mkfs() {
-  if [ -n "$MKFS" ] ; then
-     einfo "Running $MKFS on $TARGET"
-     $MKFS $TARGET
-     eend $?
   fi
 }
 # }}}
@@ -655,7 +697,7 @@ mount_target() {
      einfo "Running grml-debootstrap on a directory, nothing to mount."
   else
      if grep -q $TARGET /proc/mounts ; then
-        eerror "$TARGET already mounted, exiting."
+        ewarn "$TARGET already mounted, continuing anyway." ; eend 0
      else
        [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
        einfo "Mounting $TARGET to $MNTPOINT"
@@ -674,13 +716,18 @@ mount_target() {
 
 # install main chroot {{{
 debootstrap_system() {
-  if ! grep -q $MNTPOINT /proc/mounts ; then
-     mount_target
+  if [ "$_opt_nodebootstrap" ]; then
+     einfo "Skipping debootstrap as requested."
+     return
   fi
-  if grep -q $MNTPOINT /proc/mounts ; then
-     einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
-     [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR || \
-     $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $ISO
+
+  if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
+     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
+     if [ -n "$MIRROR" ] ; then
+        $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR
+     else
+        $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
+     fi
      eend $?
   else
      eerror "Error: $MNTPOINT not mounted, can not continue."
@@ -692,66 +739,123 @@ debootstrap_system() {
 # prepare chroot via chroot-script {{{
 preparechroot() {
   einfo "Preparing chroot system"
-  cp $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
+
+  # provide variables to chroot system
+  CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
+  touch $CHROOT_VARIABLES
+  chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
+  echo "# Configuration of ${PN}"                              > $CHROOT_VARIABLES
+  [ -n "$ARCH" ]          && echo "ARCH=$ARCH"                 >> $CHROOT_VARIABLES
+  [ -n "$GRUB" ]          && echo "GRUB=$GRUB"                 >> $CHROOT_VARIABLES
+  [ -n "$HOSTNAME" ]      && echo "HOSTNAME=$HOSTNAME"         >> $CHROOT_VARIABLES
+  [ -n "$INSTALL_NOTES" ] && echo "INSTALL_NOTES=$INSTALL_NOTES" >> $CHROOT_VARIABLES
+  [ -n "$ISODIR" ]        && echo "ISODIR=$ISO"                >> $CHROOT_VARIABLES
+  [ -n "$ISO" ]           && echo "ISO=$ISO"                   >> $CHROOT_VARIABLES
+  [ -n "$MIRROR" ]        && echo "MIRROR=$MIRROR"             >> $CHROOT_VARIABLES
+  [ -n "$KEEP_SRC_LIST" ] && echo "KEEP_SRC_LIST=$KEEP_SRC_LIST" >> $CHROOT_VARIABLES
+  [ -n "$PACKAGES" ]      && echo "PACKAGES=$PACKAGES"         >> $CHROOT_VARIABLES
+  [ -n "$ROOTPASSWORD" ]  && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
+  [ -n "$TARGET" ]        && echo "TARGET=$TARGET"             >> $CHROOT_VARIABLES
+  [ -n "$TARGET_UUID" ]   && echo "TARGET_UUID=$TARGET_UUID"   >> $CHROOT_VARIABLES
+
+  cp $VERBOSE $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
   chmod 755 $MNTPOINT/bin/chroot-script
-  mkdir $MNTPOINT/etc/debootstrap/
+  [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
 
   # make sure we have our files for later use via chroot-script
-  cp /etc/debootstrap/config    $MNTPOINT/etc/debootstrap/
+  cp $VERBOSE $CONFFILES/config    $MNTPOINT/etc/debootstrap/
   # make sure we adjust the configuration variables accordingly:
   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" $MNTPOINT/etc/debootstrap/config
   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    $MNTPOINT/etc/debootstrap/config
   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          $MNTPOINT/etc/debootstrap/config
-  sed -i "s#GROOT=.*#GROOT=\"$GROOT\"#"       $MNTPOINT/etc/debootstrap/config
 
-  cp /etc/debootstrap/packages  $MNTPOINT/etc/debootstrap/packages
+  # install notes:
+  if [ -n "$INSTALL_NOTES" ] ; then
+     [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" $MNTPOINT/etc/debootstrap/
+  fi
+
+  # package selection:
+  cp $VERBOSE ${_opt_packages:-$CONFFILES/packages} \
+    $MNTPOINT/etc/debootstrap/packages
+
+  # debconf preseeding:
+  _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
+  [ -f $_opt_debconf -a "$DEBCONF" = 'yes' ] && \
+    cp $VERBOSE $_opt_debconf $MNTPOINT/etc/debootstrap/debconf-selections
+
+  # copy scripts that should be executed inside the chroot:
+  _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
+  [ -d $_opt_chroot_scripts -a "$CHROOT_SCRIPTS" = 'yes' ] && {
+    mkdir -p $MNTPOINT/etc/debootstrap/chroot-scripts
+    cp -a $VERBOSE $_opt_chroot_scripts/* $MNTPOINT/etc/debootstrap/chroot-scripts/
+  }
 
   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
-  cp $CHROOT_VARIABLES          $MNTPOINT/etc/debootstrap/variables
+  cp $VERBOSE $CHROOT_VARIABLES  $MNTPOINT/etc/debootstrap/variables
 
-  cp -a /etc/debootstrap/extrapackages/ $MNTPOINT/etc/debootstrap/
+  cp $VERBOSE -a -L $CONFFILES/extrapackages/ $MNTPOINT/etc/debootstrap/
 
   # make sure we can access network [relevant for cdebootstrap]
-  [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
+  [ -f "$MNTPOINT/etc/resolv.conf" ] || cp $VERBOSE /etc/resolv.conf $MNTPOINT/etc/resolv.conf
 
   # provide system's /etc/hosts to the target:
   if ! [ -f "$MNTPOINT/etc/hosts" ] ; then
-     cp /etc/hosts $MNTPOINT/etc/hosts
-     sed -i "s#127.0.0.1 .*#127.0.0.1       localhost  $HOSTNAME#" /etc/hosts
+     cp $VERBOSE /etc/hosts $MNTPOINT/etc/hosts
   fi
 
   # setup default locales
-  [ -n "$LOCALES" ] && cp /etc/debootstrap/locale.gen  $MNTPOINT/etc/locale.gen
+  [ -n "$LOCALES" ] && cp $VERBOSE $CONFFILES/locale.gen  $MNTPOINT/etc/locale.gen
 
   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
   ( cd $MNTPOINT/dev && tar zxf /etc/debootstrap/devices.tar.gz )
 
-  # copy any existing existing files to chroot
-  [ -d /etc/debootstrap/boot  ] && cp -a /etc/debootstrap/boot/*  $MNTPOINT/boot/
-  [ -d /etc/debootstrap/etc   ] && cp -a /etc/debootstrap/etc/*   $MNTPOINT/etc/
-  [ -d /etc/debootstrap/share ] && cp -a /etc/debootstrap/share/* $MNTPOINT/share/
-  [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
-  [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
+  # copy any existing files to chroot
+  [ -d $CONFFILES/bin   ] && cp $VERBOSE -a -L $CONFFILES/bin/*   $MNTPOINT/bin/
+  [ -d $CONFFILES/boot  ] && cp $VERBOSE -a -L $CONFFILES/boot/*  $MNTPOINT/boot/
+  [ -d $CONFFILES/etc   ] && cp $VERBOSE -a -L $CONFFILES/etc/*   $MNTPOINT/etc/
+  [ -d $CONFFILES/sbin  ] && cp $VERBOSE -a -L $CONFFILES/sbin/*  $MNTPOINT/sbin/
+  [ -d $CONFFILES/share ] && cp $VERBOSE -a -L $CONFFILES/share/* $MNTPOINT/share/
+  [ -d $CONFFILES/usr   ] && cp $VERBOSE -a -L $CONFFILES/usr/*   $MNTPOINT/usr/
+  [ -d $CONFFILES/var   ] && cp $VERBOSE -a -L $CONFFILES/var/*   $MNTPOINT/var/
 
   # copy local network setup to chroot
   if [ -r /etc/network/interfaces -a ! -r "${MNTPOINT}"/etc/network/interfaces ] ; then
      [ -d $MNTPOINT/etc/network ] || mkdir $MNTPOINT/etc/network
-     cp /etc/network/interfaces $MNTPOINT/etc/network/interfaces
+     cp $VERBOSE /etc/network/interfaces $MNTPOINT/etc/network/interfaces
   fi
 
   eend 0
 }
 # }}}
 
+# execute all scripts in /etc/debootstrap/scripts/ {{{
+execute_scripts() {
+   # make sure we have $MNTPOINT available for our scripts
+   export MNTPOINT
+   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
+      [ -d "$_opt_scripts" ] && scripts="$_opt_scripts" || scripts="$CONFFILES/scripts/"
+      for script in ${scripts}/* ; do
+         if [ -x "$script" ] ; then
+            einfo "Executing script $script"
+            $script ; eend $?
+         fi
+      done
+   fi
+}
+# }}}
+
 # execute chroot-script {{{
 chrootscript() {
   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
      mount_target
   fi
+
   if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
      einfo "Executing chroot-script now"
-     chroot "$MNTPOINT" /bin/chroot-script
-     eend $?
+     mount --bind /dev "$MNTPOINT"/dev
+     chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
+     umount "$MNTPOINT"/dev
+     eend $RC
   else
      eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
      eend 1
@@ -761,31 +865,36 @@ chrootscript() {
 
 # install booloader grub {{{
 grub_install() {
-  if [ -z "$GRUB" -o -z "$GROOT" ] ; then
-     echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
-  elif [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
+  if [ -z "$GRUB" ] ; then
+     echo "Notice: \$GRUB not defined, will not install grub therefore."
+     return 0
+  fi
+
+  if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
      for device in $SELECTED_PARTITIONS ; do
-        # TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}')
-        # GRUB="$(grubdevice ${TMPDEVICE})"
-        # GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})"
-        # GRUB=$(grubdevice $device)
-        GRUB="$(grubdevice ${device%%[0-9]})"
+        GRUB="${device%%[0-9]}"
         einfo "Installing grub on ${GRUB}:"
         [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
-        $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
+        $GRUBINSTALL --root-directory="$MNTPOINT" "$GRUB"
         eend $?
      done
   else
      einfo "Installing grub on ${GRUB}:"
      [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
-     $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
+     $GRUBINSTALL --root-directory="$MNTPOINT" "$GRUB"
      eend $?
   fi
 }
 # }}}
 
-# unmount $MNTPOINRT {{{
+# unmount $MNTPOINT {{{
 umount_chroot() {
+
+  # display installation notes:
+  if [ -n "$INSTALL_NOTES" ] ; then
+     [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
+  fi
+
   if [ -n "$ISODIR" ] ; then
      if grep -q "$ISODIR" /proc/mounts ; then
         einfo "Unmount $MNTPOINT/$ISODIR"
@@ -793,6 +902,7 @@ umount_chroot() {
         eend $?
      fi
   fi
+
   if grep -q "$MNTPOINT" /proc/mounts ; then
      if [ -n "$PARTITION" ] ; then
         einfo "Unmount $MNTPOINT"
@@ -816,7 +926,8 @@ fscktool() {
 
 # now execute all the functions {{{
 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
-         chrootscript grub_install umount_chroot fscktool ; do
+         chrootscript execute_scripts grub_install umount_chroot   \
+         fscktool ; do
     if stage "${i}" ; then
        $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
     fi